#ifndef _CHRONOPTICS_TOF_MIXED_PIXEL_LUT_H_
#define _CHRONOPTICS_TOF_MIXED_PIXEL_LUT_H_

#include <chronoptics/tof/error.h>

#ifdef __cplusplus
extern "C" {
#endif

/** Mixed Pixel Comression Function enum. The mixed pixel lookup table contains
 * more useful information in some parts of the table then others. We can
 * compress the less useful information by taking the sqrt() or log() of the
 * table. Currently only the sqrt() is implimented.
 */
enum tof_mp_lut_compression {
  TOF_MP_LUT_COMPRESSION_NONE = 0, /** No compression function is used */
  TOF_MP_LUT_COMPRESSION_SQRT = 1, /** The sqrt function is used */
  TOF_MP_LUT_COMPRESSION_LOG2 = 2, /** The natural log */
  TOF_MP_LUT_COMPRESSION_LOG10 = 3, /** Use log10 */
  TOF_MP_LUT_COMPRESSION_BINARY = 4, /** Knocking out binary bits to compress the table */
};

#ifdef __cplusplus
}
#endif

#endif
