
#include <chronoptics/tof/gige_interface.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define CHECK_ERROR(error)                    \
  if (error) {                                \
    printf("%s\n", tof_error_message(error)); \
    tof_error_delete(error);                  \
    return -1;                                \
  }

// Example of how to discover cameras using the C interface
int main() {
  tof_discovery_message_t *msgs;
  tof_error_t error = NULL;
  size_t size;
  size_t n;
  tof_gige_interface_t cam;

  cam = tof_gige_interface_new(0, &error);
  CHECK_ERROR(error);

  size = tof_gige_interface_discover(cam, NULL, 0, &error);
  CHECK_ERROR(error);

  msgs = malloc(size);

  size = tof_gige_interface_discover(cam, msgs, size, &error);
  CHECK_ERROR(error);

  // Now print the found cameras.
  for (n = 0; n < size; n++) {
    const char *serial = tof_discovery_message_serial(msgs[n], &error);
    CHECK_ERROR(error);

    const char *ip = tof_discovery_message_ip(msgs[n], &error);
    CHECK_ERROR(error);

    printf("Serial: %s IP Address: %s\n", serial, ip);
  }

  return 0;
}